import * as SERVER from '@minecraft/server';

SERVER.world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('xaierg:contaminate', {
        onRandomTick: e => spread(e.block),
        onPlayerDestroy: e => spread(e.block),
        onPlayerInteract: e => summonPig(e.block),
    });
});

    initEvent.blockComponentRegistry.registerCustomComponent('xaierg:fungus_veins', {
        onRandomTick: e => growVeins(e.block),
                    e.block.setType('xaierg:smile_fungus_flor')
    });
});

function growVeins(block) {
    const veinBlockTypes = [
        'xaierg:smile_fungus_veins',
        'xaierg:smile_fungus_veins2',
        'xaierg:smile_fungus_veins_a',
        'xaierg:smile_fungus_veins_a2',
        'xaierg:smile_fungus_veins_b',
        'xaierg:smile_fungus_veins_b_2',
        'xaierg:smile_fungus_veins_b2',
        'xaierg:smile_fungus_veins_b2_2',
        'xaierg:smile_fungus_veins_b1',
        'xaierg:smile_fungus_veins_b1_2',
        'xaierg:smile_fungus_veins_c',
        'xaierg:smile_fungus_veins_c2'
    ];

    const aboveBlock = block.above(1);

    if (aboveBlock && aboveBlock.isAir) {
        const randomVeinType = veinBlockTypes[Math.floor(Math.random() * veinBlockTypes.length)];
        aboveBlock.setType(randomVeinType);

        // Reemplazamos el bloque de vena por el bloque de flor después de un tiempo
        setTimeout(() => {
            aboveBlock.setType('xaierg:smile_fungus_flor');
        }, 1000); // 1 segundo
    }
}

function spread(block) {
    const randomBlockType = Math.random() < 0.5 ? 'xaierg:smile_fungus_inerte' : 'xaierg:smile_fungus_flor' ;


    const adjacentBlocks = [
        block.above(1),
        block.below(1),
        block.north(1),
        block.east(1),
        block.south(1),
        block.west(1)
    ];

    adjacentBlocks.forEach(adjacentBlock => {
        if (adjacentBlock && !adjacentBlock.isAir && !['xaierg:smile_fungus_inerte', 'xaierg:smile_fungus_flor', 'xaierg:smile_fungus_veins_gen',
        'xaierg:smile_fungus_veins',
        'xaierg:smile_fungus_veins2',
        'xaierg:smile_fungus_veins_a',
        'xaierg:smile_fungus_veins_a2',
        'xaierg:smile_fungus_veins_b',
        'xaierg:smile_fungus_veins_b_2',
        'xaierg:smile_fungus_veins_b2',
        'xaierg:smile_fungus_veins_b2_2',
        'xaierg:smile_fungus_veins_b1',
        'xaierg:smile_fungus_veins_b1_2',
        'xaierg:smile_fungus_veins_c',
        'xaierg:smile_fungus_veins_c2'
    ].includes(adjacentBlock.typeId)) {
            adjacentBlock.setType(Math.random() < 0.2 ? randomBlockType : 'xaierg:smile_fungus');
        }
    });

    block.dimension.getEntities({ location: block.location, maxDistance: 10 })
        .forEach(entity => {
            if (entity.typeId !== 'minecraft:player' && entity.typeId !== 'minecraft:cow' && entity.typeId !== 'minecraft:item') {
                block.dimension.spawnEntity('xaierg:smile_control', entity.location);
                entity.kill(); 
            } else if (entity.typeId === 'minecraft:item') {
                entity.kill();
            }
        });
}

function summonPig(block) {
    block.dimension.spawnEntity('minecraft:pig', block.location);
}
